diff --git a/src/train_cmd.cpp b/src/train_cmd.cpp
index 88fa3d1..9f5b564 100644
--- a/src/train_cmd.cpp
+++ b/src/train_cmd.cpp
@@ -2439,38 +2640,413 @@ static Track ChooseTrainTrack(Vehicle *v, TileIndex tile, DiagDirection enterdir
 		} break;
 	}
 
-	/* handle "path not found" state */
-	if (path_not_found) {
-		/* PF didn't find the route */
-		if (!HasBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION)) {
-			/* it is first time the problem occurred, set the "path not found" flag */
-			SetBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION);
-			/* and notify user about the event */
-			if (_settings_client.gui.lost_train_warn && v->owner == _local_player) {
-				SetDParam(0, v->unitnumber);
-				AddNewsItem(
-					STR_TRAIN_IS_LOST,
-					NS_ADVICE,
-					v->index,
-					0);
+#ifdef PF_BENCHMARK
+	TOC("PF time = ", 1)
+#endif
+
+	return best_track;
+}
+
+/**
+ * Extend a train path as far as possible. Stops on encountering a safe tile,
+ * another reservation or a track choice.
+ * @return INVALID_TILE indicates that the reservation failed.
+ */
+static PBSTileInfo ExtendTrainReservation(const Vehicle *v, TrackBits *new_tracks, DiagDirection *enterdir)
+{
+	bool no_90deg_turns = _settings_game.pf.pathfinder_for_trains != VPF_NTP && _settings_game.pf.forbid_90_deg;
+	PBSTileInfo origin = FollowTrainReservation(v);
+
+	CFollowTrackRail ft(v);
+
+	TileIndex tile = origin.tile;
+	Trackdir  cur_td = origin.trackdir;
+	while (ft.Follow(tile, cur_td)) {
+		if (KillFirstBit(ft.m_new_td_bits) == TRACKDIR_BIT_NONE) {
+			/* Possible signal tile. */
+			if (HasOnewaySignalBlockingTrackdir(ft.m_new_tile, FindFirstTrackdir(ft.m_new_td_bits))) break;
+		}
+
+		if (no_90deg_turns) {
+			ft.m_new_td_bits &= ~TrackdirCrossesTrackdirs(ft.m_old_td);
+			if (ft.m_new_td_bits == TRACKDIR_BIT_NONE) break;
+		}
+
+		/* Station, depot or waypoint are a possible target. */
+		bool target_seen = ft.m_is_station || (IsTileType(ft.m_new_tile, MP_RAILWAY) && !IsPlainRailTile(ft.m_new_tile));
+		if (target_seen || KillFirstBit(ft.m_new_td_bits) != TRACKDIR_BIT_NONE) {
+			/* Choice found or possible target encountered.
+			 * On finding a possible target, we need to stop and let the pathfinder handle the
+			 * remaining path. This is because we don't know if this target is in one of our
+			 * orders, so we might cause pathfinding to fail later on if we find a choice.
+			 * This failure would cause a bogous call to TryReserveSafePath which might reserve
+			 * a wrong path not leading to our next destination. */
+			if (HasReservedTracks(ft.m_new_tile, TrackdirBitsToTrackBits(ft.m_new_td_bits))) break;
+
+			/* Choice found, path valid but not okay. Save info about the choice tile as well. */
+			if (new_tracks) *new_tracks = TrackdirBitsToTrackBits(ft.m_new_td_bits);
+			if (enterdir) *enterdir = ft.m_exitdir;
+			return PBSTileInfo(ft.m_new_tile, ft.m_old_td, false);
+		}
+
+		tile = ft.m_new_tile;
+		cur_td = FindFirstTrackdir(ft.m_new_td_bits);
+
+		/* CFollowTrackRail skips station tiles, reserve those skipped tiles as well. */
+		if (ft.m_is_station && ft.m_tiles_skipped > 0) {
+			TileIndexDiff diff = TileOffsByDiagDir(ft.m_exitdir);
+			TileIndex st = TILE_ADD(ft.m_new_tile, -ft.m_tiles_skipped * diff);
+			for (int i = 0; i < ft.m_tiles_skipped; ++i, st += diff) {
+				if (GetRailwayStationReservation(st)) {
+					ft.m_new_tile = st;
+					break;
+				}
+				SetRailwayStationReservation(st, true);
 			}
 		}
+
+		if (IsSafeWaitingPosition(v, tile, cur_td, true, no_90deg_turns)) {
+			bool wp_free = IsWaitingPositionFree(v, tile, cur_td, no_90deg_turns);
+			if (!(wp_free && TryReserveRailTrack(tile, TrackdirToTrack(cur_td)))) break;
+			/* Safe position is all good, path valid and okay. */
+			return PBSTileInfo(tile, cur_td, true);
+		}
+
+		if (!TryReserveRailTrack(tile, TrackdirToTrack(cur_td))) break;
+	}
+
+	if (ft.m_err == CFollowTrackRail::EC_OWNER && ft.m_err == CFollowTrackRail::EC_NO_WAY) {
+		/* End of line, path valid and okay. */
+		return PBSTileInfo(ft.m_old_tile, ft.m_old_td, true);
+	}
+
+	/* Sorry, can't reserve path, back out. */
+	tile = ft.m_new_tile;
+	ft.m_new_tile = origin.tile;
+	ft.m_new_td_bits = TrackdirToTrackdirBits(origin.trackdir);
+	while (ft.Follow(ft.m_new_tile, FindFirstTrackdir(ft.m_new_td_bits))) {
+		/* Check for skipped station tiles. */
+		if (ft.m_is_station && ft.m_tiles_skipped > 0) {
+			TileIndexDiff diff = TileOffsByDiagDir(ft.m_exitdir);
+			TileIndex st = TILE_ADD(ft.m_new_tile, -ft.m_tiles_skipped * diff);
+			for (int i = 0; i < ft.m_tiles_skipped; ++i, st += diff) {
+				if (st == tile) break;
+				SetRailwayStationReservation(st, false);
+			}
+		}
+
+		/* Break on reaching the previous failure. */
+		if (ft.m_new_tile == tile) break;
+
+		if (no_90deg_turns) {
+			ft.m_new_td_bits &= ~TrackdirCrossesTrackdirs(ft.m_old_td);
+			assert(ft.m_new_td_bits != TRACKDIR_BIT_NONE);
+		}
+
+		assert(KillFirstBit(ft.m_new_td_bits) == TRACKDIR_BIT_NONE);
+		UnreserveRailTrack(ft.m_new_tile, TrackdirToTrack(FindFirstTrackdir(ft.m_new_td_bits)));
+	}
+	/* Path invalid. */
+	return PBSTileInfo();
+}
+
+/**
+ * Try to reserve any path to a safe tile, ignoring the vehicle's destination.
+ * Safe tiles are tiles in front of a signal, depots and station tiles at end of line.
+ *
+ * @param v The vehicle.
+ * @param tile The tile the search should start from.
+ * @param td The trackdir the search should start from.
+ * @param override_tailtype Whether all physically compatible railtypes should be followed.
+ * @return True if a path to a safe stopping tile could be reserved.
+ */
+static bool TryReserveSafeTrack(const Vehicle* v, TileIndex tile, Trackdir td, bool override_tailtype)
+{
+	if (_settings_game.pf.pathfinder_for_trains == VPF_YAPF) {
+		return YapfRailFindNearestSafeTile(v, tile, td, override_tailtype);
 	} else {
-		/* route found, is the train marked with "path not found" flag? */
-		if (HasBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION)) {
-			/* clear the flag as the PF's problem was solved */
-			ClrBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION);
-			/* can we also delete the "News" item somehow? */
+		return NPFRouteToSafeTile(v, tile, td, override_tailtype).res_okay;
+	}
+}
+
+/**
+ * Query the next order after a certain order index.
+ *
+ * @param v The vehicle
+ * @param order_index [in/out] Index of the current order, returns index of the chosen order
+ * @return Pointer to the order or NULL if the order chain was completely followed
+ *          without finding a suitable order.
+ */
+static const Order* GetNextTrainOrder(const Vehicle *v, VehicleOrderID *order_index)
+{
+	++(*order_index);
+
+	do {
+		/* Wrap around. */
+		if (*order_index >= v->num_orders) *order_index = 0;
+
+		Order *order = GetVehicleOrder(v, *order_index);
+		assert(order != NULL);
+
+		switch (order->GetType()) {
+			case OT_GOTO_DEPOT:
+				/* Skip service in depot orders when the train doesn't need service. */
+				if ((order->GetDepotOrderType() & ODTFB_SERVICE) && !v->NeedsServicing()) break;
+			case OT_GOTO_STATION:
+			case OT_GOTO_WAYPOINT:
+				return order;
+			case OT_CONDITIONAL: {
+				VehicleOrderID next = ProcessConditionalOrder(order, v);
+				if (next != INVALID_VEH_ORDER_ID) {
+					*order_index = next;
+					continue;
+				}
+				break;
+			}
+			default:
+				break;
 		}
+
+		++(*order_index);
+	} while (*order_index != v->cur_order_index);
+
+	return NULL;
+}
+
+/* choose a track */
+static Track ChooseTrainTrack(Vehicle* v, TileIndex tile, DiagDirection enterdir, TrackBits tracks, bool force_res, bool *got_reservation, bool mark_stuck)
+{
+	Track best_track = INVALID_TRACK;
+	bool do_track_reservation = _settings_game.pf.reserve_paths || force_res;
+	bool changed_signal = false;
+
+	assert((tracks & ~TRACK_BIT_MASK) == 0);
+
+	if (got_reservation != NULL) *got_reservation = false;
+
+	/* Don't use tracks here as the setting to forbid 90 deg turns might have been switched between reservation and now. */
+	TrackBits res_tracks = (TrackBits)(GetReservedTrackbits(tile) & DiagdirReachesTracks(enterdir));
+	/* Do we have a suitable reserved track? */
+	if (res_tracks != TRACK_BIT_NONE) return FindFirstTrack(res_tracks);
+
+	/* Quick return in case only one possible track is available */
+	if (KillFirstBit(tracks) == TRACK_BIT_NONE) {
+		Track track = FindFirstTrack(tracks);
+		/* We need to check for signals only here, as a junction tile can't have signals. */
+		if (track != INVALID_TRACK && HasPbsSignalOnTrackdir(tile, TrackEnterdirToTrackdir(track, enterdir))) {
+			do_track_reservation = true;
+			changed_signal = true;
+			SetSignalStateByTrackdir(tile, TrackEnterdirToTrackdir(track, enterdir), SIGNAL_STATE_GREEN);
+		} else if (!do_track_reservation) {
+			return track;
+		}
+		best_track = track;
 	}
 
-#ifdef PF_BENCHMARK
-	TOC("PF time = ", 1)
-#endif
+	PBSTileInfo   res_dest(tile, INVALID_TRACKDIR, false);
+	DiagDirection dest_enterdir = enterdir;
+	if (do_track_reservation) {
+		/* Check if the train needs service here, so it has a chance to always find a depot.
+		 * Also check if the current order is a service order so we don't reserve a path to
+		 * the destination but instead to the next one if service isn't needed. */
+		CheckIfTrainNeedsService(v);
+		if (v->current_order.IsType(OT_DUMMY) || v->current_order.IsType(OT_CONDITIONAL) || v->current_order.IsType(OT_GOTO_DEPOT)) ProcessOrders(v);
+
+		res_dest = ExtendTrainReservation(v, &tracks, &dest_enterdir);
+		if (res_dest.tile == INVALID_TILE) {
+			/* Reservation failed? */
+			if (mark_stuck) MarkTrainAsStuck(v);
+			if (changed_signal) SetSignalStateByTrackdir(tile, TrackEnterdirToTrackdir(best_track, enterdir), SIGNAL_STATE_RED);
+			return FindFirstTrack(tracks);
+		}
+	}
+
+	if (res_dest.tile != INVALID_TILE && !res_dest.okay) {
+		/* Pathfinders are able to tell that route was only 'guessed'. */
+		bool      path_not_found = false;
+		TileIndex new_tile = res_dest.tile;
+
+		Track next_track = DoTrainPathfind(v, new_tile, dest_enterdir, tracks, &path_not_found, do_track_reservation, &res_dest);
+		if (new_tile == tile) best_track = next_track;
+
+		/* handle "path not found" state */
+		if (path_not_found) {
+			/* PF didn't find the route */
+			if (!HasBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION)) {
+				/* it is first time the problem occurred, set the "path not found" flag */
+				SetBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION);
+				/* and notify user about the event */
+				if (_settings_client.gui.lost_train_warn && v->owner == _local_player) {
+					SetDParam(0, v->unitnumber);
+					AddNewsItem(
+						STR_TRAIN_IS_LOST,
+						NS_ADVICE,
+						v->index,
+						0);
+				}
+			}
+		} else {
+			/* route found, is the train marked with "path not found" flag? */
+			if (HasBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION)) {
+				/* clear the flag as the PF's problem was solved */
+				ClrBit(v->u.rail.flags, VRF_NO_PATH_TO_DESTINATION);
+				/* can we also delete the "News" item somehow? */
+			}
+		}
+	}
+
+	/* No track reservation requested -> finished. */
+	if (!do_track_reservation) return best_track;
+
+	/* A path was found, but could not be reserved. */
+	if (res_dest.tile != INVALID_TILE && !res_dest.okay) {
+		if (mark_stuck) MarkTrainAsStuck(v);
+		if (!IsFrontEngine(v)) error("Vehicle %d is no front engine! First %p, veh %p.", v->First()->unitnumber, v->First(), v);
+		FreeTrainTrackReservation(v);
+		return best_track;
+	}
+
+	/* No possible reservation target found, we are probably lost. */
+	if (res_dest.tile == INVALID_TILE) {
+		/* Try to find any safe destination. */
+		PBSTileInfo origin = FollowTrainReservation(v);
+		if (TryReserveSafeTrack(v, origin.tile, origin.trackdir, false)) {
+			TrackBits res = GetReservedTrackbits(tile) & DiagdirReachesTracks(enterdir);
+			best_track = FindFirstTrack(res);
+			TryReserveRailTrack(v->tile, TrackdirToTrack(GetVehicleTrackdir(v)));
+			if (got_reservation != NULL) *got_reservation = true;
+			if (changed_signal) MarkTileDirtyByTile(tile);
+		} else {
+			if (!IsFrontEngine(v)) error("Vehicle %d is no front engine! First %p, veh %p.", v->First()->unitnumber, v->First(), v);
+			FreeTrainTrackReservation(v);
+			if (mark_stuck) MarkTrainAsStuck(v);
+		}
+		return best_track;
+	}
+
+	if (got_reservation != NULL) *got_reservation = true;
+
+	/* Reservation target found and free, check if it is safe. */
+	Order          cur_order = v->current_order;
+	TileIndex      cur_dest_tile = v->dest_tile;
+	VehicleOrderID order_index = v->cur_order_index;
+	while (!IsSafeWaitingPosition(v, res_dest.tile, res_dest.trackdir, true, _settings_game.pf.forbid_90_deg)) {
+		/* Extend reservation until we have found a safe position. */
+		DiagDirection exitdir = TrackdirToExitdir(res_dest.trackdir);
+		TileIndex     next_tile = TileAddByDiagDir(res_dest.tile, exitdir);
+		TrackBits     reachable = TrackdirBitsToTrackBits((TrackdirBits)(GetTileTrackStatus(next_tile, TRANSPORT_RAIL, 0))) & DiagdirReachesTracks(exitdir);
+		if (_settings_game.pf.pathfinder_for_trains != VPF_NTP && _settings_game.pf.forbid_90_deg) {
+			reachable &= ~TrackCrossesTracks(TrackdirToTrack(res_dest.trackdir));
+		}
+
+		/* Get next order with destination. */
+		const Order *order = GetNextTrainOrder(v, &order_index);
+		if (order != NULL) {
+			v->current_order = *order;
+			UpdateOrderDest(v, order);
+			PBSTileInfo cur_dest;
+			DoTrainPathfind(v, next_tile, exitdir, reachable, NULL, true, &cur_dest);
+			if (cur_dest.tile != INVALID_TILE) {
+				res_dest = cur_dest;
+				if (res_dest.okay) continue;
+				/* Path found, but could not be reserved. */
+				if (!IsFrontEngine(v)) error("Vehicle %d is no front engine! First %p, veh %p.", v->First()->unitnumber, v->First(), v);
+				FreeTrainTrackReservation(v);
+				if (mark_stuck) MarkTrainAsStuck(v);
+				if (got_reservation != NULL) *got_reservation = false;
+				changed_signal = false;
+				break;
+			}
+		}
+		/* No order or no safe position found, try any position. */
+		if (!TryReserveSafeTrack(v, res_dest.tile, res_dest.trackdir, true)) {
+			if (!IsFrontEngine(v)) error("Vehicle %d is no front engine! First %p, veh %p.", v->First()->unitnumber, v->First(), v);
+			FreeTrainTrackReservation(v);
+			if (mark_stuck) MarkTrainAsStuck(v);
+			if (got_reservation != NULL) *got_reservation = false;
+			changed_signal = false;
+		}
+		break;
+	}
+	v->current_order = cur_order;
+	v->dest_tile = cur_dest_tile;
+
+	TryReserveRailTrack(v->tile, TrackdirToTrack(GetVehicleTrackdir(v)));
+
+	if (changed_signal) MarkTileDirtyByTile(tile);
 
 	return best_track;
 }
 
+/**
+ * Try to reserve a path to a safe position.
+ *
+ * @param v The vehicle
+ * @return True if a path could be reserved
+ */
+static bool TryPathReserve(Vehicle *v, bool first_tile_okay)
+{
+	assert(IsFrontEngine(v));
+
+	/* We have to handle depots specially as the track follower won't look
+	 * at the depot tile itself but starts from the next tile. If we are still
+	 * inside the depot, a depot reservation can never be ours. */
+	if (v->u.rail.track & TRACK_BIT_DEPOT) {
+		if (GetDepotReservation(v->tile)) {
+			return false;
+		} else {
+			/* Depot not reserved, but the next tile might be. */
+			TileIndex next_tile = TileAddByDiagDir(v->tile, GetRailDepotDirection(v->tile));
+			if (HasReservedTracks(next_tile, DiagdirReachesTracks(GetRailDepotDirection(v->tile)))) return false;
+		}
+	}
+
+	/* Special check if we are in front of a two-sided conventional signal. */
+	DiagDirection dir = TrainExitDir(v->direction, v->u.rail.track);
+	TileIndex next_tile = TileAddByDiagDir(v->tile, dir);
+	if (IsTileType(next_tile, MP_RAILWAY) && HasReservedTracks(next_tile, DiagdirReachesTracks(dir))) {
+		/* Can have only one reserved trackdir. */
+		Trackdir td = FindFirstTrackdir((TrackdirBits)(GetReservedTrackbits(next_tile) * 0x101 & DiagdirReachesTrackdirs(dir)));
+		if (HasSignalOnTrackdir(next_tile, td) && HasSignalOnTrackdir(next_tile, ReverseTrackdir(td)) &&
+				!IsPbsSignal(GetSignalType(next_tile, TrackdirToTrack(td)))) {
+			/* Signal already reserved, is not ours. */
+			return false;
+		}
+	}
+
+	PBSTileInfo origin = FollowTrainReservation(v);
+	/* If we have a reserved path and the path ends at a safe tile, we are finished already. */
+	if (origin.okay && (v->tile != origin.tile || first_tile_okay)) {
+		/* Can't be stuck then. */
+		ClrBit(v->u.rail.flags, VRF_TRAIN_STUCK);
+		return true;
+	}
+
+	/* If we are in a depot, tentativly reserve the depot. */
+	if (v->u.rail.track & TRACK_BIT_DEPOT) {
+		SetDepotReservation(v->tile, true);
+		if (_settings_client.gui.show_track_reservation) MarkTileDirtyByTile(v->tile);
+	}
+
+	DiagDirection exitdir = TrackdirToExitdir(origin.trackdir);
+	TileIndex     new_tile = TileAddByDiagDir(origin.tile, exitdir);
+	TrackBits     reachable = TrackdirBitsToTrackBits((TrackdirBits)GetTileTrackStatus(new_tile, TRANSPORT_RAIL, 0) & DiagdirReachesTrackdirs(exitdir));
+
+	if (_settings_game.pf.pathfinder_for_trains != VPF_NTP && _settings_game.pf.forbid_90_deg) reachable &= ~TrackCrossesTracks(TrackdirToTrack(origin.trackdir));
+
+	bool res_made = false;
+	ChooseTrainTrack(v, new_tile, exitdir, reachable, true, &res_made, false);
+
+	if (!res_made) {
+		/* Free the depot reservation as well. */
+		if (v->u.rail.track & TRACK_BIT_DEPOT) SetDepotReservation(v->tile, false);
+		return false;
+	}
+
+	ClrBit(v->u.rail.flags, VRF_TRAIN_STUCK);
+	return true;
+}
+
 
 static bool CheckReverseTrain(Vehicle *v)
 {
@@ -2606,7 +3182,7 @@ static int UpdateTrainSpeed(Vehicle *v)
 {
 	uint accel;
 
-	if (v->vehstatus & VS_STOPPED || HasBit(v->u.rail.flags, VRF_REVERSING)) {
+	if (v->vehstatus & VS_STOPPED || HasBit(v->u.rail.flags, VRF_REVERSING) || HasBit(v->u.rail.flags, VRF_TRAIN_STUCK)) {
 		if (_settings_game.vehicle.realistic_acceleration) {
 			accel = GetTrainAcceleration(v, AM_BRAKE) * 2;
 		} else {
@@ -2778,14 +3354,18 @@ static inline void AffectSpeedByZChange(Vehicle *v, byte old_z)
 	}
 }
 
-static void TrainMovedChangeSignals(TileIndex tile, DiagDirection dir)
+static bool TrainMovedChangeSignals(TileIndex tile, DiagDirection dir)
 {
 	if (IsTileType(tile, MP_RAILWAY) &&
 			GetRailTileType(tile) == RAIL_TILE_SIGNALS) {
 		TrackdirBits tracks = TrackBitsToTrackdirBits(GetTrackBits(tile)) & DiagdirReachesTrackdirs(dir);
 		Trackdir trackdir = FindFirstTrackdir(tracks);
-		UpdateSignalsOnSegment(tile, TrackdirToExitdir(trackdir), GetTileOwner(tile));
+		if (UpdateSignalsOnSegment(tile,  TrackdirToExitdir(trackdir), GetTileOwner(tile)) == SIGSEG_PBS && HasSignalOnTrackdir(tile, trackdir)) {
+			/* A PBS block with a non-PBS signal facing us? */
+			if (!IsPbsSignal(GetSignalType(tile, TrackdirToTrack(trackdir)))) return true;
+		}
 	}
+	return false;
 }
 
 
@@ -2793,6 +3373,14 @@ static void SetVehicleCrashed(Vehicle *v)
 {
 	if (v->u.rail.crash_anim_pos != 0) return;
 
+	/* Free a possible path reservation and try to mark all tiles occupied by the train reserved. */
+	if (IsFrontEngine(v)) {
+		FreeTrainTrackReservation(v);
+		for (const Vehicle *u = v; u != NULL; u = u->Next()) {
+			TryReserveRailTrack(u->tile, TrackdirToTrack(GetVehicleTrackdir(u)));
+		}
+	}
+
 	/* we may need to update crossing we were approaching */
 	TileIndex crossing = TrainApproachingCrossingTile(v);
 
@@ -2948,6 +3536,10 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 						TrainEnterStation(v, r >> VETS_STATION_ID_OFFSET);
 						return;
 					}
+					if (v->Next() == NULL && IsRailDepotTile(v->tile) && HasBit(r, VETS_ENTERED_WORMHOLE)) {
+						SetDepotReservation(v->tile, false);
+						if (_settings_client.gui.show_track_reservation) MarkTileDirtyByTile(v->tile);
+					}
 
 					if (v->current_order.IsType(OT_LEAVESTATION)) {
 						v->current_order.Free();
@@ -2987,7 +3579,7 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 				if (prev == NULL) {
 					/* Currently the locomotive is active. Determine which one of the
 					 * available tracks to choose */
-					chosen_track = TrackToTrackBits(ChooseTrainTrack(v, gp.new_tile, enterdir, bits));
+					chosen_track = TrackToTrackBits(ChooseTrainTrack(v, gp.new_tile, enterdir, bits, false, NULL, true));
 					assert(chosen_track & bits);
 
 					/* Check if it's a red signal and that force proceed is not clicked. */
@@ -2995,6 +3587,9 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 						/* In front of a red signal */
 						Trackdir i = FindFirstTrackdir(trackdirbits);
 
+						/* Don't handle stuck trains here. */
+						if (HasBit(v->u.rail.flags, VRF_TRAIN_STUCK)) return;
+
 						if (!HasSignalOnTrackdir(gp.new_tile, ReverseTrackdir(i))) {
 							v->cur_speed = 0;
 							v->subspeed = 0;
@@ -3012,6 +3607,13 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 								if (VehicleFromPos(o_tile, &rdir, &CheckVehicleAtSignal) == NULL) return;
 							}
 						}
+
+						/* If we would reverse but are currently in a PBS block and reversing of
+						 * stuck trains is disabled, don't reverse and mark stuck instead. */
+						if (_settings_game.pf.wait_for_pbs_path == 255 && UpdateSignalsOnSegment(v->tile, enterdir, v->owner) == SIGSEG_PBS) {
+							MarkTrainAsStuck(v);
+							return;
+						}
 						goto reverse_train_direction;
 					}
 				} else {
@@ -3047,6 +3649,16 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 				if (IsFrontEngine(v)) v->load_unload_time_rem = 0;
 
 				if (!HasBit(r, VETS_ENTERED_WORMHOLE)) {
+					Track track = FindFirstTrack(chosen_track);
+					Trackdir tdir = TrackDirectionToTrackdir(track, chosen_dir);
+					if (IsFrontEngine(v) && HasPbsSignalOnTrackdir(gp.new_tile, tdir)) {
+						SetSignalStateByTrackdir(gp.new_tile, tdir, SIGNAL_STATE_RED);
+						MarkTileDirtyByTile(gp.new_tile);
+					}
+
+					/* Clear any track reservation when the last vehicle leaves the tile */
+					if (v->Next() == NULL) ClearPathReservation(v->tile, GetVehicleTrackdir(v));
+
 					v->tile = gp.new_tile;
 
 					if (GetTileRailType(gp.new_tile) != GetTileRailType(gp.old_tile)) {
@@ -3064,6 +3676,15 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 				if (prev == NULL) AffectSpeedByDirChange(v, chosen_dir);
 
 				v->direction = chosen_dir;
+
+				if (IsFrontEngine(v)) {
+					/* If we are approching a crossing that is reserved, play the sound now. */
+					TileIndex crossing = TrainApproachingCrossingTile(v);
+					if (crossing != INVALID_TILE && GetCrossingReservation(crossing)) SndPlayTileFx(SND_0E_LEVEL_CROSSING, crossing);
+
+					/* Always try to extend the reservation when entering a tile. */
+					CheckNextTrainTile(v);
+				}
 			}
 		} else {
 			/* In a tunnel or on a bridge
@@ -3074,7 +3695,10 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 					min(v->cur_speed, GetBridgeSpec(GetBridgeType(v->tile))->speed);
 			}
 
-			if (!IsTileType(gp.new_tile, MP_TUNNELBRIDGE) || !HasBit(VehicleEnterTile(v, gp.new_tile, gp.x, gp.y), VETS_ENTERED_WORMHOLE)) {
+			if (IsTileType(gp.new_tile, MP_TUNNELBRIDGE) && HasBit(VehicleEnterTile(v, gp.new_tile, gp.x, gp.y), VETS_ENTERED_WORMHOLE)) {
+				/* Perform look-ahead on tunnel exit. */
+				CheckNextTrainTile(v);
+			} else {
 				v->x_pos = gp.x;
 				v->y_pos = gp.y;
 				VehiclePositionChanged(v);
@@ -3099,7 +3723,21 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 		}
 
 		if (update_signals_crossing) {
-			if (IsFrontEngine(v)) TrainMovedChangeSignals(gp.new_tile, enterdir);
+			if (IsFrontEngine(v)) {
+				if (TrainMovedChangeSignals(gp.new_tile, enterdir)) {
+					/* We are entering a block with PBS signals right now, but
+					 * not through a PBS signal. This means we don't have a
+					 * reservation right now. As a conventional signal will only
+					 * ever be green if no other train is in the block, getting
+					 * a path should always be possible. If the player built
+					 * such a strange network that it is not possible, the train
+					 * will be marked as stuck and the player has to deal with
+					 * the problem. */
+					if (!(HasReservedTracks(gp.new_tile, v->u.rail.track) ||
+								TryReserveRailTrack(gp.new_tile, FindFirstTrack(v->u.rail.track))) ||
+							!TryPathReserve(v)) MarkTrainAsStuck(v);
+				}
+			}
 
 			/* Signals can only change when the first
 			 * (above) or the last vehicle moves. */
@@ -3108,6 +3746,9 @@ static void TrainController(Vehicle *v, Vehicle *nomove, bool update_image)
 				if (IsLevelCrossingTile(gp.old_tile)) UpdateLevelCrossing(gp.old_tile);
 			}
 		}
+
+		/* Do not check on every tick to save some computing time. */
+		if (IsFrontEngine(v) && v->tick_counter % _settings_game.pf.path_backoff_interval == 0) CheckNextTrainTile(v);
 	}
 	return;
 
@@ -3158,6 +3799,31 @@ static void DeleteLastWagon(Vehicle *v)
 
 	MarkSingleVehicleDirty(v);
 
+	/* Clear a possible path reservation */
+	if (IsFrontEngine(v)) {
+		if (IsTileType(v->tile, MP_TUNNELBRIDGE) && GetTunnelBridgeReservation(v->tile)) {
+			DiagDirection dir = ReverseDiagDir(GetTunnelBridgeDirection(v->tile));
+			ClearPathReservation(v->tile, DiagDirToDiagTrackdir(dir));
+		} else if (IsRailwayStationTile(v->tile) && GetRailwayStationReservation(v->tile)) {
+			DiagDirection dir = AxisToDiagDir(GetRailStationAxis(v->tile));
+			SetRailwayStationPlatformReservation(v->tile, dir, false);
+			SetRailwayStationPlatformReservation(v->tile, ReverseDiagDir(dir), false);
+		} else if (v->u.rail.track == TRACK_BIT_DEPOT && GetDepotReservation(v->tile)) {
+			SetDepotReservation(v->tile, false);
+		} else if (HasReservedTracks(v->tile, v->u.rail.track)) {
+			Trackdir td = TrackToTrackdir(TrackBitsToTrack(v->u.rail.track));
+			ClearPathReservation(v->tile, td);
+			if (HasPbsSignalOnTrackdir(v->tile, td)) SetSignalStateByTrackdir(v->tile, td, SIGNAL_STATE_RED);
+			if (HasPbsSignalOnTrackdir(v->tile, ReverseTrackdir(td))) SetSignalStateByTrackdir(v->tile, ReverseTrackdir(td), SIGNAL_STATE_RED);
+		}
+	} else if ((v->u.rail.track & ~TRACK_BIT_MASK) == TRACK_BIT_NONE && u->tile != v->tile && HasReservedTracks(v->tile, v->u.rail.track)) {
+		DiagDirection dir = DiagDirByTileIndexDiff(TileIndexToTileIndexDiffC(u->tile, v->tile));
+		Trackdir      td = TrackExitdirToTrackdir(TrackBitsToTrack(v->u.rail.track), dir);
+		assert(IsValidTrackdir(td));
+
+		ClearPathReservation(v->tile, td);
+	}
+
 	/* 'v' shouldn't be accessed after it has been deleted */
 	TrackBits track = v->u.rail.track;
 	TileIndex tile = v->tile;
@@ -3433,7 +4099,10 @@ static void TrainLocoHandler(Vehicle *v, bool mode)
 		return;
 	}
 
-	if (v->u.rail.force_proceed != 0) v->u.rail.force_proceed--;
+	if (v->u.rail.force_proceed != 0) {
+		v->u.rail.force_proceed--;
+		ClrBit(v->u.rail.flags, VRF_TRAIN_STUCK);
+	}
 
 	/* train is broken down? */
 	if (v->breakdown_ctr != 0) {
@@ -3451,6 +4120,7 @@ static void TrainLocoHandler(Vehicle *v, bool mode)
 	/* exit if train is stopped */
 	if (v->vehstatus & VS_STOPPED && v->cur_speed == 0) return;
 
+	bool valid_order = v->current_order.IsValid() && v->current_order.GetType() != OT_CONDITIONAL;
 	if (ProcessOrders(v) && CheckReverseTrain(v)) {
 		v->load_unload_time_rem = 0;
 		v->cur_speed = 0;
@@ -3467,6 +4137,42 @@ static void TrainLocoHandler(Vehicle *v, bool mode)
 
 	if (!mode) HandleLocomotiveSmokeCloud(v);
 
+	/* We had no order but have an order now, do look ahead. */
+	if (!valid_order && v->current_order.IsValid()) {
+		CheckNextTrainTile(v);
+	}
+
+	/* Handle stuck trains. */
+	if (!mode && HasBit(v->u.rail.flags, VRF_TRAIN_STUCK)) {
+		++v->load_unload_time_rem;
+
+		/* Should we try reversing this tick if still stuck? */
+		bool turn_around = v->load_unload_time_rem % (_settings_game.pf.wait_for_pbs_path * DAY_TICKS) == 0 && _settings_game.pf.wait_for_pbs_path < 255;
+
+		if (!turn_around && v->load_unload_time_rem % _settings_game.pf.path_backoff_interval != 0 && v->u.rail.force_proceed == 0) return;
+		if (!TryPathReserve(v)) {
+			/* Still stuck. */
+			if (turn_around) ReverseTrainDirection(v);
+
+			if (HasBit(v->u.rail.flags, VRF_TRAIN_STUCK) && v->load_unload_time_rem > 2 * _settings_game.pf.wait_for_pbs_path * DAY_TICKS) {
+				/* Show message to player. */
+				if (_settings_client.gui.lost_train_warn && v->owner == _local_player) {
+					SetDParam(0, v->unitnumber);
+					AddNewsItem(
+						STR_TRAIN_IS_STUCK,
+						NS_ADVICE,
+						v->index,
+						0);
+				}
+				v->load_unload_time_rem = 0;
+			}
+			/* Exit if force proceed not pressed, else reset stuck flag anyway. */
+			if (v->u.rail.force_proceed == 0) return;
+			ClrBit(v->u.rail.flags, VRF_TRAIN_STUCK);
+			v->load_unload_time_rem = 0;
+		}
+	}
+
 	int j = UpdateTrainSpeed(v);
 
 	/* we need to invalidate the widget if we are stopping from 'Stopping 0 km/h' to 'Stopped' */
diff --git a/src/tunnelbridge_cmd.cpp b/src/tunnelbridge_cmd.cpp
index ab05372..9bdff69 100644
--- a/src/tunnelbridge_cmd.cpp
+++ b/src/tunnelbridge_cmd.cpp
@@ -885,6 +885,13 @@ static void DrawTile_TunnelBridge(TileInfo *ti)
 
 		image += tunnelbridge_direction * 2;
 		DrawGroundSprite(image, PAL_NONE);
+
+		/* PBS debugging, draw reserved tracks darker */
+		if (_settings_client.gui.show_track_reservation && (transport_type == TRANSPORT_RAIL && GetTunnelBridgeReservation(ti->tile))) {
+			const RailtypeInfo *rti = GetRailTypeInfo(GetRailType(ti->tile));
+			DrawGroundSprite(DiagDirToAxis(tunnelbridge_direction) == AXIS_X ? rti->base_sprites.single_y : rti->base_sprites.single_x, PALETTE_CRASH);
+		}
+
 		if (transport_type == TRANSPORT_ROAD) {
 			RoadTypes rts = GetRoadTypes(ti->tile);
 
@@ -961,6 +968,15 @@ static void DrawTile_TunnelBridge(TileInfo *ti)
 		/* Bridge heads are drawn solid no matter how invisibility/transparency is set */
 		AddSortableSpriteToDraw(psid->sprite, psid->pal, ti->x, ti->y, 16, 16, ti->tileh == SLOPE_FLAT ? 0 : 8, ti->z);
 
+		if (_settings_client.gui.show_track_reservation && transport_type == TRANSPORT_RAIL && GetTunnelBridgeReservation(ti->tile)) {
+			const RailtypeInfo *rti = GetRailTypeInfo(GetRailType(ti->tile));
+			if (HasBridgeFlatRamp(ti->tileh, DiagDirToAxis(tunnelbridge_direction))) {
+				AddSortableSpriteToDraw(DiagDirToAxis(tunnelbridge_direction) == AXIS_X ? rti->base_sprites.single_y : rti->base_sprites.single_x, PALETTE_CRASH, ti->x, ti->y, 16, 16, 0, ti->z + 8);
+			} else {
+				AddSortableSpriteToDraw(rti->base_sprites.single_sloped + tunnelbridge_direction, PALETTE_CRASH, ti->x, ti->y, 16, 16, 8, ti->z);
+			}
+		}
+
 		if (transport_type == TRANSPORT_ROAD) {
 			RoadTypes rts = GetRoadTypes(ti->tile);
 
